SystemOrganization addCategory: #'GT-Debugger'!

GLMBrowserTemplate subclass: #GTDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugger commentStamp: 'TudorGirba 3/13/2011 23:28' prior: 0!
[ GTDebugger debugProcess: Processor activeProcess.
	Processor activeProcess suspend.
	#(1 2 3 4 5) do: [:each | each asString]
] fork.!

!GTDebugger classSide methodsFor: 'as yet unclassified' stamp: 'AdrianLienhard 2/26/2011 17:19'!
debugIn: anArray

	<primitive: 19> "simulation guard"
	
	
	WorldState addDeferredUIMessage: [ self openOn: anArray ].! !

!GTDebugger classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/12/2011 16:39'!
debugProcess: aProcess

	<primitive: 19> "simulation guard"
	
	WorldState addDeferredUIMessage: [
		self openOn: (GTDebuggerModel process: aProcess) ].! !

!GTDebugger methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/31/2012 09:44'!
actOnBrowserClosing: ann
	self model terminate.! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 10/31/2012 10:45'!
buildBrowser
	browser := GLMTabulator new.
	browser title: 'Glamorous Debugger'.
	browser on: GLMBrowserClosing send: #actOnBrowserClosing: to: self.
	
	browser
		row: [:row| row column: #stack; column: #code];
		row: #inspector span: 2.

	browser transmit to: #stack; andShow: [ :composite | |presentation| 
		presentation := composite list 
			title: 'Stack';
			showOnly: 10;
			display: #stack;
			format: [ :each | each methodClass name , '>>' , each methodSelector ].
		self  installBrowserActions: presentation ].
	
	browser transmit fromOutsidePort: #entity; to: #stack port: #selection; transformed: #context.
	
	browser transmit from: #stack port: #selection; fromOutsidePort: #entity; to: #stack port: #context; 
		transformed: [:context :model |  model methodModel: context ].
		
	browser transmit from: #stack port: #selection; to: #stack port: #pc; 
		transformed: #pc.
	
	browser transmit from: #stack port: #context; fromOutsidePort: #entity; to: #code; andShow: [ :composite |
		composite smalltalkCode  
			selectionAct: [:text :model | model evaluate: text selectedText ] on: $; entitled: 'Do (;)';
			selectionAct: [:text :model | (model evaluate: text selectedText) printString ] on: $/ entitled: 'Print (/)';
			selectionAct: [:text :model | (model evaluate: text selectedText) inspect ] on: $' entitled: 'Inspect ('')';
			title: 'Source';
			format: #sourceText;
			smalltalkClass: [ :model | model receiverClass ]].
		
	browser transmit from: #stack; fromOutsidePort: #entity; from: #stack port: #pc; to: #code port: #selectionInterval;
		transformed: [ :context :model :pc | model selectedCodeRange: context ].
	
	browser transmit from: #stack port: #context; to: #inspector; andShow: [ :composite |
		composite dynamic 
			display: [:each | 
				GTInspector new browser 
					noTitle;
					noActions;
					showFirst: [:a | a custom: (GTDebuggerVariablesBrowser new browser startOn: each) ]; 
					startOn: each  ] ]! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 10:44'!
installBrowserActions: aPresentation
	self installRestartAction: aPresentation.
	self installStepIntoAction: aPresentation.
	self installStepOverAction: aPresentation.
	self installStepThroughAction: aPresentation.
	self installResumeAction: aPresentation ! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 10:45'!
installRestartAction: aPresentation 
	aPresentation 
		act: [ :presentation :model |
			model restart: self selectedContext.
			self selectTopOfStack: model context  ]
		icon: GLMUIThemeExtraIcons glamorousRestart
		entitled: 'Restart'! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 10:41'!
installResumeAction: aPresentation
	aPresentation 
		act: [ :presentation :model |
			model resume.
			browser close. ]
		icon: GLMUIThemeExtraIcons glamorousPlay
		entitled: 'Resume' ! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 11:52'!
installStepIntoAction: aPresentation 
	aPresentation 
		act: [ :presentation :model |
			model stepInto: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousInto
		entitled: 'Step into' ! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 10:46'!
installStepOverAction: aPresentation
	aPresentation 
		act: [ :presentation :model |
			model stepOver: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousOver
		entitled: 'Step over' ! !

!GTDebugger methodsFor: 'private building' stamp: 'AndreiChis 10/31/2012 10:46'!
installStepThroughAction: aPresentation
	aPresentation 
		act: [ :presentation :model |
			model stepThrough: self selectedContext.
			self selectTopOfStack: model context ]
		icon: GLMUIThemeExtraIcons glamorousOver
		entitled: 'Step through' ! !

!GTDebugger methodsFor: 'private' stamp: 'AndreiChis 10/23/2012 15:56'!
keyAsFormatedString: key

	^ [ Text fromString: (key asString contractTo: 50) ]
			on: Error
			do: [ Text string: 'error printing' attribute: TextColor red ] ! !

!GTDebugger methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 16:00'!
model
	^ (browser pane port: #entity) value! !

!GTDebugger methodsFor: 'private' stamp: 'AndreiChis 10/31/2012 09:29'!
selectTopOfStack: aContext
	| stackPane |
	stackPane := browser paneNamed: #stack.
	(stackPane port: #selection) value: aContext.
	(stackPane port: #pc) value: aContext pc.
	stackPane update! !

!GTDebugger methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 18:28'!
selectedContext
	^ ((browser paneNamed: #stack) port: #selection) value! !

!GTDebugger methodsFor: 'private' stamp: 'AndreiChis 10/23/2012 15:58'!
valueAsFormatedString: value

	^ [ Text fromString: value printString]
			on: Error
			do: [ Text string: 'error printing' attribute: TextColor red ] ! !

GLMBrowserTemplate subclass: #GTDebuggerVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerVariablesBrowser methodsFor: 'building' stamp: 'AndreiChis 10/30/2012 20:59'!
buildBrowser 
	browser := GLMTabulator new.
	browser title: 'State'.
	browser row: #variables; row: #evaluator.
	browser transmit to: #variables; andShow: [:a | 
		self variablesIn: a ].
	browser transmit to: #evaluator; andShow: [:a | 
		self evaluatorIn: a ].
	browser transmit from: #variables; toOutsidePort: #selection.
	browser transmit from: #evaluator; toOutsidePort: #selection.
	^ browser ! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 10/30/2012 21:03'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :model | [model receiver printString asSmalltalkComment, String cr, 'self'] on: Error do: ['"Error printing. Try self printString to debug"'] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :model | Compiler evaluate: text selectedText for: model receiver logged: false ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 10/30/2012 21:01'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :anObject | anObject gtDebuggerRetrieveVariableValuePairs ];
		sorted: [:assoc1 :assoc2 | assoc1 key < assoc2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

!PreDebugWindow methodsFor: '*gt-debugger' stamp: 'AndreiChis 10/31/2012 12:07'!
spanNewDebugger
	model spanNewDebugger! !

Object subclass: #GTDebugContextModel
	instanceVariableNames: 'context latestContext method methodNode ranges'
	classVariableNames: 'MapCache MapCacheEntries'
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugContextModel classSide methodsFor: 'instance creation' stamp: 'AndreiChis 10/30/2012 16:54'!
forContext: aContext fromProcess: aProcess
	^ self new forContext: aContext fromProcess: aProcess! !

!GTDebugContextModel methodsFor: 'evaluating actions' stamp: 'AndreiChis 10/30/2012 19:21'!
evaluate: expression
	^ Compiler new
		evaluate: expression
		in: context
		to: context receiver! !

!GTDebugContextModel methodsFor: 'instance creation' stamp: 'AndreiChis 10/30/2012 16:55'!
forContext: aContext fromProcess: aProcess
	method := aContext method.
	methodNode := method methodNode.

	ranges := Dictionary new.
	
	" Put all ranges with a possitive Key PC in the ranges dictionary "
	methodNode rawSourceRanges
		keysAndValuesDo: [ :node :range |
			node pc = 0
				ifFalse: [ ranges at: node pc put: range ]].
			
	context := aContext.
	latestContext := aProcess suspendedContext 

	" Sort all the Key PCs in the sortedKeyPCs "
	"sortedKeyPCs := SortedCollection new."
	" ranges keysDo: [ :pc | sortedKeyPCs add: pc ]."! !

!GTDebugContextModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/31/2012 09:31'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList|

	fieldList := OrderedCollection new.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index | 
			(context tempNames at: index ) -> (context debuggerMap namedTempAt: index in: context ) ] ) ].
	
	^ fieldList! !

!GTDebugContextModel methodsFor: 'accessing' stamp: 'AndreiChis 10/30/2012 21:02'!
receiver
	^ context receiver! !

!GTDebugContextModel methodsFor: 'accessing' stamp: 'AndreiChis 10/30/2012 19:25'!
receiverClass
	^ context receiver class! !

!GTDebugContextModel methodsFor: 'accessing' stamp: 'AndreiChis 10/30/2012 16:47'!
source
	^ method holdsTempNames
		ifTrue: [ method getSource ]
		ifFalse: [ methodNode sourceText ]! !

!GTDebugContextModel methodsFor: 'accessing' stamp: 'AndreiChis 10/30/2012 16:47'!
sourceRangeForPC: pc
	^ ranges at: pc ifAbsent: [ ^ 1 to: 0 ].! !

!GTDebugContextModel methodsFor: 'accessing' stamp: 'AndreiChis 10/30/2012 16:47'!
sourceText
	^ self source asText! !

Object subclass: #GTDebuggerModel
	instanceVariableNames: 'context process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerModel classSide methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/12/2011 16:39'!
process: aProcess
	^ self new
		process: aProcess! !

!GTDebuggerModel methodsFor: 'private process' stamp: 'ToonVerwaest 3/12/2011 16:54'!
activePC: aContext
	^ (self isLatestContext: aContext)
		ifTrue: [ context pc ]
		ifFalse: [ self previousPC: aContext ].! !

!GTDebuggerModel methodsFor: 'private' stamp: 'AndreiChis 10/26/2012 12:21'!
clear
	process := nil.
	context := nil.! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 10:13'!
context
	^ context! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 20:15'!
currentCodeRange: aContext
	^(self methodModel: aContext) sourceRangeForPC: (self activePC: aContext)! !

!GTDebuggerModel methodsFor: 'evaluating actions' stamp: 'ToonVerwaest 3/12/2011 13:13'!
evaluate: expression in: aContext
	^ Compiler new
		evaluate: expression
		in: aContext
		to: aContext receiver! !

!GTDebuggerModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/25/2012 20:51'!
gtInspectorPresentationsInText: composite
	"Add all the presentation belonging to the current context and its receiver"
	|objectPresentation contextPresentation|
	
	"this does not work"
	"self context gtInspectorPresentationsIn: composite.
	self context receiver gtInspectorPresentationsIn: composite"
	
	"this also does not work"
	contextPresentation := GLMCompositePresentation new.
	contextPresentation title: [self context class printString].
	self context gtInspectorPresentationsIn: contextPresentation.
	composite custom: (contextPresentation startOn: self context).
	
	objectPresentation := GLMCompositePresentation new.
	objectPresentation title: [self context receiver class printString].
	self context receiver gtInspectorPresentationsIn: objectPresentation.
	composite 
		custom: (objectPresentation startOn: self context receiver);
		display: [:anObject | self context receiver].
	
	
	! !

!GTDebuggerModel methodsFor: 'as yet unclassified' stamp: 'AndreiChis 10/25/2012 12:00'!
gtInspectorRetrieveVariableValuePairs
	|fieldList|

	fieldList := OrderedCollection new.
	fieldList 
		add: ('self' -> self context receiver).
		"add: ('all inst vars' -> (self context receiver longPrintStringLimitedTo: 20000)).	"

	fieldList add: ('thisContext' -> self context).
	self context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('stack top' -> (self context stackPtr > 0 ifTrue: [self context top])).
		"add: ('all temp vars' -> self context tempsAndValues)."
		
	^ fieldList! !

!GTDebuggerModel methodsFor: 'private process' stamp: 'ToonVerwaest 3/12/2011 16:52'!
isLatestContext: aContext
	^ process suspendedContext == aContext! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'AndreiChis 10/30/2012 16:56'!
methodModel: aContext
	^ GTDebugContextModel forContext: aContext fromProcess: process! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 16:50'!
previousPC: aContext
	^ (aContext method pcPreviousTo: aContext pc)
		ifNil: [ aContext pc ]! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 10:13'!
process
	^ process! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'AndreiChis 10/22/2012 10:13'!
process: aProcess
	aProcess stepToSendOrReturn.
	context := aProcess suspendedContext.
	process := aProcess! !

!GTDebuggerModel methodsFor: 'private context' stamp: 'ToonVerwaest 3/12/2011 18:31'!
receiverClass: aContext
	^ aContext receiver class! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 12:45'!
restart: selectedContext
	self unwindTo: selectedContext.
	process
		restartTop;
		stepToSendOrReturn! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'AndreiChis 10/31/2012 09:39'!
resume
	process resume.
	self clear.! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 18:40'!
selectedCodeRange: selectedContext
	^ self currentCodeRange: selectedContext! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 14:49'!
stack
	^ context stack! !

!GTDebuggerModel methodsFor: 'accessing' stamp: 'ToonVerwaest 3/12/2011 11:45'!
stackOfSize: size
	^ context stackOfSize: size! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:28'!
stepInto
	self stepInto: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:33'!
stepInto: selectedContext
	context := process step: selectedContext.
	process stepToSendOrReturn.! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:29'!
stepOver
	self stepOver: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/12/2011 13:32'!
stepOver: selectedContext
	| newContext |
	newContext := process completeStep: selectedContext.
	context := 
		newContext == selectedContext
			ifTrue: [ process stepToSendOrReturn ]
			ifFalse: [ selectedContext ]! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/16/2011 11:19'!
stepThrough
	self stepThrough: context! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'ToonVerwaest 3/16/2011 11:24'!
stepThrough: selectedContext
	"Send messages until you return to the present method context.
	 Used to step into a block in the method."
	self halt.
	context := process stepToHome: selectedContext.
	process stepToSendOrReturn.! !

!GTDebuggerModel methodsFor: 'debugging actions' stamp: 'AndreiChis 10/26/2012 12:21'!
terminate
	self process isNil ifFalse: [self process terminate].
	self clear.! !

!GTDebuggerModel methodsFor: 'private' stamp: 'ToonVerwaest 3/12/2011 12:45'!
unwindTo: aContext
	|ctx|
	ctx := process popTo: aContext.
	ctx == aContext ifFalse: [ self error: 'Could not unwind stack' ].
	context := aContext! !

Debugger subclass: #GTProxyDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTProxyDebugger methodsFor: 'initialize' stamp: 'AndreiChis 10/31/2012 11:57'!
preDebugButtonQuads
	| buttons |
	self isPostMortem 
		ifTrue: [ ^ self postMortemPreDebugButtonQuads ].
	^ {
		{'Proceed' translated.	#proceed. 	#blue. 	'Continue execution' translated}.
		{'Abandon' translated.	#abandon. 	#black.	'Abandon this execution by closing this window' translated}.
		{'Debug'    		translated.		#debug.		#red. 	'Bring up a debugger' translated}.
		{'New Debugger' translated. #spanNewDebugger. #red. 'Bring up the new debugger' translated}
	}! !

!GTProxyDebugger methodsFor: 'notifier menu' stamp: 'AndreiChis 10/31/2012 13:41'!
spanNewDebugger
	"Open a full DebuggerView."
	| topView |
	topView := self topView.
	topView model: nil.
	"so close won't release me."
	self breakDependents.
	topView delete.
	
	GTDebugger debugProcess: self interruptedProcess! !
